"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _highlighter = require("./highlighter");

var _highlighter2 = _interopRequireDefault(_highlighter);

var _stepParser = require("./step-parser");

var _stepParser2 = _interopRequireDefault(_stepParser);

var _scroller = require("./scroller");

var Scroller = _interopRequireWildcard(_scroller);

var _glamor = require("glamor");

var _theme = require("./theme");

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

//TODO configure theme
//TODO don't import css
// import "prismjs/themes/prism.css";


(0, _theme2.default)();

function getFullLineHtml(showNumber, number, line) {
  var numberHtml = '<span class="token comment token-leaf line-number" style="user-select: none">' + String(number).padStart(3) + ".</span> ";
  return showNumber ? numberHtml + line : line || " ";
}

var getLineClassName = function getLineClassName(tokens, lineNumber) {
  if (Object.keys(tokens).length === 0) {
    return (0, _glamor.css)(_defineProperty({}, "& .token-leaf", {
      opacity: "1 !important"
    }));
  } else if (!(lineNumber in tokens)) {
    return "";
  } else if (tokens[lineNumber] == null) {
    return (0, _glamor.css)(_defineProperty({}, "& .token-leaf", {
      opacity: "1 !important"
    }));
  } else {
    return _glamor.css.apply(undefined, [_defineProperty({}, "& .token-leaf.line-number", {
      opacity: "1 !important"
    })].concat(_toConsumableArray(tokens[lineNumber].map(function (n) {
      return _defineProperty({}, "& .token-leaf.token-" + n, {
        opacity: "1 !important"
      });
    }))));
  }
};

var LineOfCode = function LineOfCode(_ref3) {
  var number = _ref3.number,
      tokensPerLine = _ref3.tokensPerLine,
      html = _ref3.html;

  var isSelected = number in tokensPerLine;
  var className = getLineClassName(tokensPerLine, number);
  return _react2.default.createElement(Scroller.Element, {
    dangerouslySetInnerHTML: { __html: html }
    // style={{ opacity: isSelected ? 1 : 0.3 }}
    , className: className,
    selected: isSelected
  });
};

var CodeSurfer = function CodeSurfer(_ref4) {
  var code = _ref4.code,
      step = _ref4.step,
      showNumbers = _ref4.showNumbers;

  var tokensPerLine = (0, _stepParser2.default)(step);
  var tokenOpacity = (0, _glamor.css)(_defineProperty({}, "& .token-leaf", {
    opacity: "0.35",
    transition: "opacity 300ms"
  }));
  return _react2.default.createElement(
    Scroller.Container,
    { type: "pre", height: 500 },
    _react2.default.createElement(
      Scroller.Content,
      { type: "code", className: tokenOpacity },
      (0, _highlighter2.default)(code).map(function (line, index) {
        return _react2.default.createElement(LineOfCode, {
          key: index,
          html: getFullLineHtml(showNumbers, index + 1, line),
          number: index + 1,
          tokensPerLine: tokensPerLine
        });
      })
    )
  );
};

exports.default = CodeSurfer;