"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _prismjs = require("prismjs");

var _prismjs2 = _interopRequireDefault(_prismjs);

var _lodash = require("lodash.memoize");

var _lodash2 = _interopRequireDefault(_lodash);

require("prismjs/components/prism-jsx.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function parseToken(token, counter) {
  if (token === "\n") {
    counter.current = 0;
    return token;
  } else if (typeof token === "string" && token.includes("\n")) {
    var _token$split = token.split("\n"),
        _token$split2 = _toArray(_token$split),
        left = _token$split2[0],
        rest = _token$split2.slice(1);

    var right = rest.join("\n");
    var tokens = addCustomTokens([left, "\n", right], counter);
    return tokens;
  } else if (typeof token === "string" && !token.trim()) {
    // whitespace
    return token;
  } else if (typeof token === "string") {
    counter.current++;
    return new _prismjs2.default.Token("free-text", token, ["token-" + counter.current, "token-leaf"], token);
  } else if (_prismjs2.default.util.type(token.content) === "Array") {
    token.content = addCustomTokens(token.content, counter);
    return token;
  } else {
    counter.current++;
    var aliases = _prismjs2.default.util.type(token.alias) === "Array" ? token.alias : [token.alias];
    aliases.push("token-" + counter.current, "token-leaf");
    token.alias = aliases;
    return token;
  }
}

function addCustomTokens(tokens) {
  var counter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { current: 0 };

  var newTokens = tokens.map(function (token) {
    return parseToken(token, counter);
  });
  // flatten
  return newTokens.concat.apply([], newTokens);
}

var highlight = function highlight(code) {
  var grammar = _prismjs2.default.languages["jsx"];
  var language = null;
  var env = {
    code: code,
    grammar: grammar,
    language: language
  };
  _prismjs2.default.hooks.run("before-tokenize", env);
  env.tokens = _prismjs2.default.tokenize(env.code, env.grammar);
  _prismjs2.default.hooks.run("after-tokenize", env);

  env.tokens = addCustomTokens(env.tokens);

  return _prismjs2.default.Token.stringify(_prismjs2.default.util.encode(env.tokens), env.language);
};

var highlightLines = function highlightLines(code) {
  var html = highlight(code);
  var lines = html.split("\n");
  if (lines.length && lines[lines.length - 1].trim() == "") {
    // Remove last line if it's empty
    lines.pop();
  }
  return lines;
};

exports.default = (0, _lodash2.default)(highlightLines);